diff --git a/tests/checkasm/Makefile b/tests/checkasm/Makefile
index de850c016e..9e9569777b 100644
--- a/tests/checkasm/Makefile
+++ b/tests/checkasm/Makefile
@@ -45,7 +45,7 @@ AVFILTEROBJS-$(CONFIG_NLMEANS_FILTER)    += vf_nlmeans.o
 CHECKASMOBJS-$(CONFIG_AVFILTER) += $(AVFILTEROBJS-yes)
 
 # swscale tests
-SWSCALEOBJS                             += sw_rgb.o
+SWSCALEOBJS                             += sw_rgb.o sw_scale.o
 
 CHECKASMOBJS-$(CONFIG_SWSCALE)  += $(SWSCALEOBJS)
 
diff --git a/tests/checkasm/checkasm.c b/tests/checkasm/checkasm.c
index d67147ae6f..91066514f6 100644
--- a/tests/checkasm/checkasm.c
+++ b/tests/checkasm/checkasm.c
@@ -183,6 +183,7 @@ static const struct {
 #endif
 #if CONFIG_SWSCALE
     { "sw_rgb", checkasm_check_sw_rgb },
+    { "sw_scale", checkasm_check_sw_scale },
 #endif
 #if CONFIG_AVUTIL
         { "fixed_dsp", checkasm_check_fixed_dsp },
diff --git a/tests/checkasm/checkasm.h b/tests/checkasm/checkasm.h
index 0a7f9f25c4..77e573774f 100644
--- a/tests/checkasm/checkasm.h
+++ b/tests/checkasm/checkasm.h
@@ -69,6 +69,7 @@ void checkasm_check_pixblockdsp(void);
 void checkasm_check_sbrdsp(void);
 void checkasm_check_synth_filter(void);
 void checkasm_check_sw_rgb(void);
+void checkasm_check_sw_scale(void);
 void checkasm_check_utvideodsp(void);
 void checkasm_check_v210dec(void);
 void checkasm_check_v210enc(void);
diff --git a/tests/checkasm/sw_scale.c b/tests/checkasm/sw_scale.c
new file mode 100644
index 0000000000..52a15247d5
--- /dev/null
+++ b/tests/checkasm/sw_scale.c
@@ -0,0 +1,114 @@
+/*
+ *
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License along
+ * with FFmpeg; if not, write to the Free Software Foundation, Inc.,
+ * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+ */
+
+#include <string.h>
+
+#include "libavutil/common.h"
+#include "libavutil/intreadwrite.h"
+#include "libavutil/mem.h"
+
+#include "libswscale/swscale.h"
+#include "libswscale/swscale_internal.h"
+
+#include "checkasm.h"
+
+#define randomize_buffers(buf, size)      \
+    do {                                  \
+        int j;                            \
+        for (j = 0; j < size; j+=4)       \
+            AV_WN32(buf + j, rnd());      \
+    } while (0)
+
+#define MAX_WIDTH 128
+
+#define FILTER_SIZES 5
+int filter_sizes[FILTER_SIZES] = { 4, 8, 16, 32, 40 };
+#define MAX_FILTER_WIDTH 40
+
+#define HSCALE_PAIRS 2
+int hscale_pairs[HSCALE_PAIRS][2] = {
+    { 8, 14 },
+    { 8, 18 },
+};
+
+static void check_hscale(void)
+{
+    int i, j, fsi, hpi, width;
+    struct SwsContext *ctx;
+
+    // padded
+    LOCAL_ALIGNED_32(uint8_t, src, [MAX_WIDTH + MAX_FILTER_WIDTH - 1]);
+    LOCAL_ALIGNED_32(uint32_t, dst0, [MAX_WIDTH]);
+    LOCAL_ALIGNED_32(uint32_t, dst1, [MAX_WIDTH]);
+
+    // padded
+    LOCAL_ALIGNED_32(int16_t, filter, [MAX_WIDTH * MAX_FILTER_WIDTH + MAX_FILTER_WIDTH]);
+    LOCAL_ALIGNED_32(int32_t, filterPos, [MAX_WIDTH]);
+
+    // The dst parameter here is either int16_t or int32_t but we use void* to
+    // just cover both cases.
+    declare_func(void, void *c, void *dst, int dstW,
+                 const uint8_t *src, const int16_t *filter,
+                 const int32_t *filterPos, int filterSize);
+
+    ctx = sws_alloc_context();
+    if (sws_init_context(ctx, NULL, NULL) < 0)
+        fail();
+
+    randomize_buffers(src, MAX_WIDTH + MAX_FILTER_WIDTH - 1);
+
+    for (hpi = 0; hpi < HSCALE_PAIRS; hpi++) {
+        for (fsi = 0; fsi < FILTER_SIZES; fsi++) {
+            width = filter_sizes[fsi];
+
+            ctx->srcBpc = hscale_pairs[hpi][0];
+            ctx->dstBpc = hscale_pairs[hpi][1];
+            ctx->hLumFilterSize = ctx->hChrFilterSize = width;
+            for (i = 0; i < MAX_WIDTH; i++) {
+                filterPos[i] = i;
+                for (j = 0; j < width; j++) {
+                    filter[i * width + j] = (1 << 14) / width;
+                }
+            }
+
+            for (i = 0; i < MAX_FILTER_WIDTH; i++) {
+                filter[MAX_WIDTH * width + i] = (1 << 14) / width;
+            }
+            ff_getSwsFunc(ctx);
+
+            if (check_func(ctx->hcScale, "hscale_%d_to_%d_width%d", ctx->srcBpc, ctx->dstBpc + 1, width)) {
+                memset(dst0, 0, MAX_WIDTH * sizeof(dst0[0]));
+                memset(dst1, 0, MAX_WIDTH * sizeof(dst1[0]));
+
+                call_ref(NULL, dst0, MAX_WIDTH, src, filter, filterPos, width);
+                call_new(NULL, dst1, MAX_WIDTH, src, filter, filterPos, width);
+                if (memcmp(dst0, dst1, MAX_WIDTH * sizeof(dst0[0])))
+                    fail();
+                bench_new(NULL, dst0, MAX_WIDTH, src, filter, filterPos, width);
+            }
+        }
+    }
+    sws_freeContext(ctx);
+}
+
+void checkasm_check_sw_scale(void)
+{
+    check_hscale();
+    report("hscale");
+}